=== debian/changelog ===
vcmi (0.99+dfsg-5ubuntu1) cosmic; urgency=medium

  * Force old boost 1.65 to fix a FTBFS with new boost

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 20 Aug 2018 15:25:09 +0200

vcmi (0.99+dfsg-5) unstable; urgency=medium

  * debian/control: fix my name in Uploaders field
  * Add patch to fix campaigns (closes: #905652)

 -- Johannes 'josch' Schauer <josch@debian.org>  Wed, 08 Aug 2018 17:15:23 +0200

vcmi (0.99+dfsg-4) unstable; urgency=medium

  * Build with ggc-min-expand=5 on mips and mipsel
  * Enable parallel build. All buildds should have enough RAM these days.

 -- Johannes Schauer <josch@debian.org>  Wed, 09 May 2018 22:34:11 +0200

vcmi (0.99+dfsg-3) unstable; urgency=medium

  * Add patch to also search /usr/share/games for assets (closes: #783030)
  * Explain what VCMI stands for in the package description
  * debian/control: Suggest usage of game-data-packager
  * debian/control: recommend ffmpeg instead of libav-tools (closes: #895918)
  * debian/control: change vcs to salsa
  * debian/copyright: Use HTTPS Format URI
  * debian/copyright: explain why the package belongs to contrib
  * debian/control: bump Standards-Version to 4.1.4 (no changes)
  * debian/rules: remove get-orig-source target and add compression=xz to
    debian/watch options
  * debian/rules: explicitly build with --no-parallel
  * Bump dh compat level to 11

 -- Johannes Schauer <josch@debian.org>  Wed, 18 Apr 2018 21:07:52 +0200

vcmi (0.99+dfsg-2) unstable; urgency=medium

  * Add patch from upstream which makes sure that removing a mod cannot
    accidentally recursively delete $HOME (closes: #863301)

 -- Johannes Schauer <josch@debian.org>  Thu, 25 May 2017 08:12:26 +0200

vcmi (0.99+dfsg-1) unstable; urgency=medium

  * new upstream release
  * remove patches boost1.60.diff, build_with_boost_1.58 and ffmpeg_2.9.patch
    as they all have been included by upstream
  * add Build-Depends on libboost-test-dev
  * add patch minizip_maxu32
  * Make Vcs fields use a secure uri
  * Bump Standards-Version to 3.9.8 (no changes required)
  * add patch fix-spelling

 -- Johannes Schauer <josch@debian.org>  Tue, 08 Nov 2016 10:35:01 -0200

vcmi (0.98+dfsg-3) unstable; urgency=medium

  * Team upload.

  [ Gianfranco Costamagna ]
  * Acknowledge previous NMU, thanks!

  [ Stephen Kitt ]
  * Migrate to dbgsym debug packages.

  [ Matthias Klose ]
  * Fix build failure with boost1.60.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 11 Aug 2016 18:33:10 +0200

vcmi (0.98+dfsg-2.1) unstable; urgency=medium

  * Non-maintainer upload.

  [ Andreas Cadhalpun ]
  * Fix build with ffmpeg 3.0. (Closes: #803866)

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 24 Apr 2016 19:35:24 +0200
